Index: src/includes/classes/Smarty/plugins/shared.literal_compiler_param.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/shared.literal_compiler_param.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/shared.literal_compiler_param.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_foreachsection.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_foreachsection.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_foreachsection.php	(revision )
@@ -0,0 +1,220 @@
+<?php
+/**
+ * Smarty Internal Plugin Compile ForeachSection
+ * Shared methods for {foreach} {section} tags
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Uwe Tews
+ */
+
+/**
+ * Smarty Internal Plugin Compile ForeachSection Class
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ */
+class Smarty_Internal_Compile_Private_ForeachSection extends Smarty_Internal_CompileBase
+{
+
+    /**
+     * Preg search pattern
+     *
+     * @var string
+     */
+    private $propertyPreg = '';
+
+    /**
+     * Offsets in preg match result
+     *
+     * @var array
+     */
+    private $resultOffsets = array();
+
+    /**
+     * Start offset
+     *
+     * @var int
+     */
+    private $startOffset = 0;
+
+    /**
+     * Name of this tag
+     *
+     * @var string
+     */
+    public $tagName = '';
+
+    /**
+     * Valid properties of $smarty.xxx variable
+     *
+     * @var array
+     */
+    public $nameProperties = array();
+
+    /**
+     * {section} tag has no item properties
+     *
+     * @var array
+     */
+    public $itemProperties = null;
+
+    /**
+     * {section} tag has always name attribute
+     *
+     * @var bool
+     */
+    public $isNamed = true;
+
+    /**
+     * @var array
+     */
+    public $matchResults = array();
+
+    /**
+     * Scan sources for used tag attributes
+     *
+     * @param  array                                $attributes
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     */
+    public function scanForProperties($attributes, Smarty_Internal_TemplateCompilerBase $compiler)
+    {
+        $this->propertyPreg = '~(';
+        $this->startOffset = 0;
+        $this->resultOffsets = array();
+        $this->matchResults = array('named' => array(), 'item' => array());
+        if ($this->isNamed) {
+            $this->buildPropertyPreg(true, $attributes);
+        }
+        if (isset($this->itemProperties)) {
+            if ($this->isNamed) {
+                $this->propertyPreg .= '|';
+            }
+            $this->buildPropertyPreg(false, $attributes);
+        }
+        $this->propertyPreg .= ')\W~i';
+        // Template source
+        $this->matchTemplateSource($compiler);
+        // Parent template source
+        $this->matchParentTemplateSource($compiler);
+        // {block} source
+        $this->matchBlockSource($compiler);
+    }
+
+    /**
+     * Build property preg string
+     *
+     * @param bool  $named
+     * @param array $attributes
+     */
+    public function buildPropertyPreg($named, $attributes)
+    {
+        if ($named) {
+            $this->resultOffsets['named'] = $this->startOffset + 3;
+            $this->propertyPreg .= "([\$]smarty[.]{$this->tagName}[.]{$attributes['name']}[.](";
+            $properties = $this->nameProperties;
+        } else {
+            $this->resultOffsets['item'] = $this->startOffset + 3;
+            $this->propertyPreg .= "([\$]{$attributes['item']}[@](";
+            $properties = $this->itemProperties;
+        }
+        $this->startOffset += count($properties) + 2;
+        $propName = reset($properties);
+        while ($propName) {
+            $this->propertyPreg .= "({$propName})";
+            $propName = next($properties);
+            if ($propName) {
+                $this->propertyPreg .= '|';
+            }
+        }
+        $this->propertyPreg .= '))';
+    }
+
+    /**
+     * Find matches in source string
+     *
+     * @param string $source
+     */
+    public function matchProperty($source)
+    {
+        preg_match_all($this->propertyPreg, $source, $match, PREG_SET_ORDER);
+        foreach ($this->resultOffsets as $key => $offset) {
+            foreach ($match as $m) {
+                if (isset($m[$offset]) && !empty($m[$offset])) {
+                    $this->matchResults[$key][strtolower($m[$offset])] = true;
+                }
+            }
+        }
+    }
+
+    /**
+     * Find matches in template source
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     */
+    public function matchTemplateSource(Smarty_Internal_TemplateCompilerBase $compiler)
+    {
+        $this->matchProperty($compiler->parser->lex->data);
+    }
+
+    /**
+     * Find matches in all parent template source
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     */
+    public function matchParentTemplateSource(Smarty_Internal_TemplateCompilerBase $compiler)
+    {
+        // search parent compiler template source
+        $nextCompiler = $compiler;
+        while ($nextCompiler !== $nextCompiler->parent_compiler) {
+            $nextCompiler = $nextCompiler->parent_compiler;
+            if ($compiler !== $nextCompiler) {
+                // get template source
+                $_content = $nextCompiler->template->source->getContent();
+                if ($_content != '') {
+                    // run pre filter if required
+                    if ((isset($nextCompiler->smarty->autoload_filters['pre']) ||
+                            isset($nextCompiler->smarty->registered_filters['pre']))) {
+                        $_content = $nextCompiler->smarty->ext->_filter_Handler->runFilter('pre', $_content, $nextCompiler->template);
+                    }
+                    $this->matchProperty($_content);
+                }
+            }
+        }
+    }
+
+    /**
+     * Find matches in {block} tag source
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     */
+    public function matchBlockSource(Smarty_Internal_TemplateCompilerBase $compiler)
+    {
+
+    }
+
+    /**
+     * Compiles code for the {$smarty.foreach.xxx} or {$smarty.section.xxx}tag
+     *
+     * @param  array                                $args      array with attributes from parser
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
+     * @param  array                                $parameter array with compilation parameter
+     *
+     * @return string compiled code
+     * @throws \SmartyCompilerException
+     */
+    public function compileSpecialVariable($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
+    {
+        $tag = strtolower(trim($parameter[ 0 ], '"\''));
+        $name = isset($parameter[ 1 ]) ? $compiler->getId($parameter[ 1 ]) : false;
+        if (!$name) {
+            $compiler->trigger_template_error("missing or illegal \$smarty.{$tag} name attribute", null, true);
+        }
+        $property = isset($parameter[ 2 ]) ? strtolower($compiler->getId($parameter[ 2 ])) : false;
+        if (!$property || !in_array($property, $this->nameProperties)) {
+            $compiler->trigger_template_error("missing or illegal \$smarty.{$tag} property attribute", null, true);
+        }
+        $tagVar = "'__smarty_{$tag}_{$name}'";
+        return "(isset(\$_smarty_tpl->tpl_vars[{$tagVar}]->value['{$property}']) ? \$_smarty_tpl->tpl_vars[{$tagVar}]->value['{$property}'] : null)";
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaulttemplatehandler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaulttemplatehandler.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerdefaulttemplatehandler.php	(revision )
@@ -0,0 +1,72 @@
+<?php
+
+/**
+ * Smarty Method RegisterDefaultTemplateHandler
+ *
+ * Smarty::registerDefaultTemplateHandler() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterDefaultTemplateHandler
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Register template default handler
+     *
+     * @api  Smarty::registerDefaultTemplateHandler()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  callable                                                       $callback class/method name
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException              if $callback is not callable
+     */
+    public function registerDefaultTemplateHandler(Smarty_Internal_TemplateBase $obj, $callback)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (is_callable($callback)) {
+            $smarty->default_template_handler_func = $callback;
+        } else {
+            throw new SmartyException("Default template handler not callable");
+        }
+        return $obj;
+    }
+
+    /**
+     * get default content from template or config resource handler
+     *
+     * @param Smarty_Template_Source $source
+     */
+    public static function _getDefaultTemplate(Smarty_Template_Source $source)
+    {
+        if ($source->isConfig) {
+            $default_handler = $source->smarty->default_config_handler_func;
+        } else {
+            $default_handler = $source->smarty->default_template_handler_func;
+        }
+        $_content = $_timestamp = null;
+        $_return = call_user_func_array($default_handler, array($source->type, $source->name, &$_content, &$_timestamp,
+                                                                $source->smarty));
+        if (is_string($_return)) {
+            $source->exists = is_file($_return);
+            if ($source->exists) {
+                $source->timestamp = filemtime($_return);
+            }
+            $source->filepath = $_return;
+        } elseif ($_return === true) {
+            $source->content = $_content;
+            $source->timestamp = $_timestamp;
+            $source->exists = true;
+            $source->handler->recompiled = true;
+            $source->filepath = false;
+        }
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_extension_clear.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_extension_clear.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_extension_clear.php	(revision )
@@ -0,0 +1,126 @@
+<?php
+
+/**
+ * Smarty Extension Clear
+ *
+ * $smarty->clear() method file cache file resource
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Extension_Clear
+{
+    /**
+     * Empty cache for a specific template
+     *
+     * @param Smarty  $smarty
+     * @param string  $resource_name template name
+     * @param string  $cache_id      cache id
+     * @param string  $compile_id    compile id
+     * @param integer $exp_time      expiration time (number of seconds, not timestamp)
+     *
+     * @return integer number of cache files deleted
+     */
+    public static function clear(Smarty $smarty, $resource_name, $cache_id, $compile_id, $exp_time)
+    {
+        $_cache_id = isset($cache_id) ? preg_replace('![^\w\|]+!', '_', $cache_id) : null;
+        $_compile_id = isset($compile_id) ? preg_replace('![^\w]+!', '_', $compile_id) : null;
+        $_dir_sep = $smarty->use_sub_dirs ? '/' : '^';
+        $_compile_id_offset = $smarty->use_sub_dirs ? 3 : 0;
+        $_dir = $smarty->getCacheDir();
+        if ($_dir == '/') { //We should never want to delete this!
+            return 0;
+        }
+        $_dir_length = strlen($_dir);
+        if (isset($_cache_id)) {
+            $_cache_id_parts = explode('|', $_cache_id);
+            $_cache_id_parts_count = count($_cache_id_parts);
+            if ($smarty->use_sub_dirs) {
+                foreach ($_cache_id_parts as $id_part) {
+                    $_dir .= $id_part . DS;
+                }
+            }
+        }
+        if (isset($resource_name)) {
+            $_save_stat = $smarty->caching;
+            $smarty->caching = true;
+            $tpl = new $smarty->template_class($resource_name, $smarty);
+            $smarty->caching = $_save_stat;
+
+            // remove from template cache
+            $tpl->source; // have the template registered before unset()
+
+            if ($tpl->source->exists) {
+                $_resourcename_parts = basename(str_replace('^', '/', $tpl->cached->filepath));
+            } else {
+                return 0;
+            }
+        }
+        $_count = 0;
+        $_time = time();
+        if (file_exists($_dir)) {
+            $_cacheDirs = new RecursiveDirectoryIterator($_dir);
+            $_cache = new RecursiveIteratorIterator($_cacheDirs, RecursiveIteratorIterator::CHILD_FIRST);
+            foreach ($_cache as $_file) {
+                if (substr(basename($_file->getPathname()), 0, 1) == '.' || strpos($_file, '.svn') !== false) {
+                    continue;
+                }
+                // directory ?
+                if ($_file->isDir()) {
+                    if (!$_cache->isDot()) {
+                        // delete folder if empty
+                        @rmdir($_file->getPathname());
+                    }
+                } else {
+                    $_parts = explode($_dir_sep, str_replace('\\', '/', substr((string) $_file, $_dir_length)));
+                    $_parts_count = count($_parts);
+                    // check name
+                    if (isset($resource_name)) {
+                        if ($_parts[$_parts_count - 1] != $_resourcename_parts) {
+                            continue;
+                        }
+                    }
+                    // check compile id
+                    if (isset($_compile_id) && (!isset($_parts[$_parts_count - 2 - $_compile_id_offset]) ||
+                            $_parts[$_parts_count - 2 - $_compile_id_offset] != $_compile_id)
+                    ) {
+                        continue;
+                    }
+                    // check cache id
+                    if (isset($_cache_id)) {
+                        // count of cache id parts
+                        $_parts_count = (isset($_compile_id)) ? $_parts_count - 2 - $_compile_id_offset :
+                            $_parts_count - 1 - $_compile_id_offset;
+                        if ($_parts_count < $_cache_id_parts_count) {
+                            continue;
+                        }
+                        for ($i = 0; $i < $_cache_id_parts_count; $i ++) {
+                            if ($_parts[$i] != $_cache_id_parts[$i]) {
+                                continue 2;
+                            }
+                        }
+                    }
+                    // expired ?
+                    if (isset($exp_time)) {
+                        if ($exp_time < 0) {
+                            preg_match('#\'cache_lifetime\' =>\s*(\d*)#', file_get_contents($_file), $match);
+                            if ($_time < (@filemtime($_file) + $match[1])) {
+                                continue;
+                            }
+                        } else {
+                            if ($_time - @filemtime($_file) < $exp_time) {
+                                continue;
+                            }
+                        }
+                    }
+                    $_count += @unlink((string) $_file) ? 1 : 0;
+                    if (function_exists('opcache_invalidate')) {
+                        opcache_invalidate((string) $_file);
+                    }
+                }
+            }
+        }
+        return $_count;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatescope.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatescope.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_updatescope.php	(revision )
@@ -0,0 +1,55 @@
+<?php
+
+/**
+ * Runtime Methods updateScope
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_UpdateScope
+{
+    /**
+     * Update new assigned template variable in other effected scopes
+     *
+     * @param \Smarty_Internal_Template $tpl     template object
+     * @param string $varName variable name
+     * @param int    $scope   scope to which bubble up variable value
+     */
+    public function updateScope(Smarty_Internal_Template $tpl, $varName, $scope = Smarty::SCOPE_LOCAL)
+    {
+        if (!$scope && !$tpl->scope) {
+            return;
+        }
+        foreach (array($scope, $tpl->scope) as $s) {
+            $s = ($bubble_up = $s >= Smarty::SCOPE_BUBBLE_UP) ? $s - Smarty::SCOPE_BUBBLE_UP : $s;
+            if ($bubble_up && $s) {
+                $ptr = $tpl->parent;
+                if (isset($ptr)) {
+                    $ptr->tpl_vars[$varName] = $tpl->tpl_vars[$varName];
+                    $ptr = $ptr->parent;
+                }
+                if ($s == Smarty::SCOPE_PARENT) {
+                    continue;
+                }
+                while (isset($ptr) && $ptr->_objType == 2) {
+                    $ptr->tpl_vars[$varName] = $tpl->tpl_vars[$varName];
+                    $ptr = $ptr->parent;
+                }
+                if ($s == Smarty::SCOPE_TPL_ROOT) {
+                    continue;
+                } elseif ($s == Smarty::SCOPE_SMARTY) {
+                    $tpl->smarty->tpl_vars[$varName] = $tpl->tpl_vars[$varName];
+                } elseif ($s == Smarty::SCOPE_GLOBAL) {
+                    Smarty::$global_tpl_vars[$varName] = $tpl->tpl_vars[$varName];
+                } elseif ($s == Smarty::SCOPE_ROOT) {
+                    while (isset($ptr->parent)) {
+                        $ptr = $ptr->parent;
+                    }
+                    $ptr->tpl_vars[$varName] = $tpl->tpl_vars[$varName];
+                }
+            }
+        }
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_resource_custom.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_resource_custom.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_resource_custom.php	(revision )
@@ -88,7 +88,7 @@
      *
      * @return string                 resource's basename
      */
-    protected function getBasename(Smarty_Template_Source $source)
+    public function getBasename(Smarty_Template_Source $source)
     {
         return basename($source->name);
     }
Index: src/includes/classes/Smarty/plugins/modifiercompiler.string_format.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.string_format.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.string_format.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_variable.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_variable.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_variable.php	(revision )
@@ -0,0 +1,47 @@
+<?php
+
+/**
+ * class for the Smarty variable object
+ * This class defines the Smarty variable object
+ *
+ * @package    Smarty
+ * @subpackage Template
+ */
+class Smarty_Variable
+{
+    /**
+     * template variable
+     *
+     * @var mixed
+     */
+    public $value = null;
+    /**
+     * if true any output of this variable will be not cached
+     *
+     * @var boolean
+     */
+    public $nocache = false;
+
+    /**
+     * create Smarty variable object
+     *
+     * @param mixed   $value   the value to assign
+     * @param boolean $nocache if true any output of this variable will be not cached
+     */
+    public function __construct($value = null, $nocache = false)
+    {
+        $this->value = $value;
+        $this->nocache = $nocache;
+    }
+
+    /**
+     * <<magic>> String conversion
+     *
+     * @return string
+     */
+    public function __toString()
+    {
+        return (string) $this->value;
+    }
+}
+
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallassign.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallassign.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallassign.php	(revision )
@@ -0,0 +1,37 @@
+<?php
+
+/**
+ * Smarty Method ClearAllAssign
+ *
+ * Smarty::clearAllAssign() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ClearAllAssign
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+    /**
+     * clear all the assigned template variables.
+     *
+     * @api  Smarty::clearAllAssign()
+     * @link http://www.smarty.net/docs/en/api.clear.all.assign.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
+     */
+    public function clearAllAssign(Smarty_Internal_Data $data)
+    {
+        $data->tpl_vars = array();
+
+        return $data;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_php.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_php.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_php.php	(revision )
@@ -9,9 +9,15 @@
  * @author     Uwe Tews
  * @author     Rodney Rehm
  */
-class Smarty_Internal_Resource_PHP extends Smarty_Resource_Uncompiled
+class Smarty_Internal_Resource_Php extends Smarty_Internal_Resource_File
 {
     /**
+     * Flag that it's an uncompiled resource
+     *
+     * @var bool
+     */
+    public $uncompiled = true;
+    /**
      * container for short_open_tag directive's value before executing PHP templates
      *
      * @var string
@@ -19,50 +25,20 @@
     protected $short_open_tag;
 
     /**
-     * Create a new PHP Resource
-
-     */
-    public function __construct()
-    {
-        $this->short_open_tag = ini_get('short_open_tag');
-    }
-
-    /**
-     * populate Source Object with meta data from Resource
+     * Resource does implement populateCompiledFilepath() method
      *
-     * @param  Smarty_Template_Source   $source    source object
-     * @param  Smarty_Internal_Template $_template template object
-     *
-     * @return void
+     * @var bool
      */
-    public function populate(Smarty_Template_Source $source, Smarty_Internal_Template $_template = null)
-    {
-        $source->filepath = $this->buildFilepath($source, $_template);
+    public $hasCompiledHandler = true;
 
-        if ($source->filepath !== false) {
-            if (is_object($source->smarty->security_policy)) {
-                $source->smarty->security_policy->isTrustedResourceDir($source->filepath);
-            }
 
-            $source->uid = sha1($source->filepath);
-            if ($source->smarty->compile_check) {
-                $source->timestamp = @filemtime($source->filepath);
-                $source->exists = !!$source->timestamp;
-            }
-        }
-    }
-
     /**
-     * populate Source Object with timestamp and exists from Resource
-     *
-     * @param  Smarty_Template_Source $source source object
-     *
-     * @return void
+     * Create a new PHP Resource
+
      */
-    public function populateTimestamp(Smarty_Template_Source $source)
+    public function __construct()
     {
-        $source->timestamp = @filemtime($source->filepath);
-        $source->exists = !!$source->timestamp;
+        $this->short_open_tag = ini_get('short_open_tag');
     }
 
     /**
@@ -75,7 +51,7 @@
      */
     public function getContent(Smarty_Template_Source $source)
     {
-        if ($source->timestamp) {
+        if ($source->exists) {
             return '';
         }
         throw new SmartyException("Unable to read template {$source->type} '{$source->name}'");
@@ -96,7 +72,7 @@
             throw new SmartyException("PHP templates are disabled");
         }
         if (!$source->exists) {
-            if ($_template->parent instanceof Smarty_Internal_Template) {
+            if (isset($_template->parent) && $_template->parent->_objType == 2) {
                 $parent_resource = " in '{$_template->parent->template_resource}'";
             } else {
                 $parent_resource = '';
@@ -115,5 +91,18 @@
         $_smarty_template = $_template;
         include($source->filepath);
         ini_set('short_open_tag', $this->short_open_tag);
+    }
+
+    /**
+     * populate compiled object with compiled filepath
+     *
+     * @param Smarty_Template_Compiled $compiled  compiled object
+     * @param Smarty_Internal_Template $_template template object (is ignored)
+     */
+    public function populateCompiledFilepath(Smarty_Template_Compiled $compiled, Smarty_Internal_Template $_template)
+    {
+        $compiled->filepath = false;
+        $compiled->timestamp = false;
+        $compiled->exists = false;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_append.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_append.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_append.php	(revision )
@@ -19,13 +19,13 @@
     /**
      * Compiles code for the {append} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                       $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                       $parameter array with compilation parameter
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // the following must be assigned at runtime because it will be overwritten in parent class
         $this->required_attributes = array('var', 'value');
Index: src/includes/classes/Smarty/plugins/shared.mb_unicode.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/shared.mb_unicode.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/shared.mb_unicode.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_eval.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_eval.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_eval.php	(revision )
@@ -73,11 +73,11 @@
      *
      * @param  Smarty  $smarty        Smarty instance
      * @param  string  $resource_name resource_name to make unique
-     * @param  boolean $is_config     flag for config resource
+     * @param  boolean $isConfig      flag for config resource
      *
      * @return string unique resource name
      */
-    protected function buildUniqueResourceName(Smarty $smarty, $resource_name, $is_config = false)
+    public function buildUniqueResourceName(Smarty $smarty, $resource_name, $isConfig = false)
     {
         return get_class($this) . '#' . $this->decode($resource_name);
     }
@@ -89,7 +89,7 @@
      *
      * @return string                 resource's basename
      */
-    protected function getBasename(Smarty_Template_Source $source)
+    public function getBasename(Smarty_Template_Source $source)
     {
         return '';
     }
